<?php
// ----------------------------------------------------------------------
// phpNewsfork - Version 0.1
// http://www.borho.net/news/
// (c) 2001-2002 Martin Borho (martin@borho.net)
//
// LICENSE
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
include("xmlrpc_m.inc");
include("syndic8.inc");

// get the input-variables
$pattern = $_REQUEST["pattern"];
$syn8_lang = $_REQUEST["syn8_lang"];
$syndicated = $_POST["syndicated"];
$polling = $_POST["polling"];
$approval = $_POST["approval"];

$get_feed = $_GET["get_feed"];
$version = $_GET["version"];
// if there's missing user-input
if (!$pattern and !$get_feed) die ("<u><i>no searchpattern is given!</i></u>");

// instance of syndic8
$news = new syndic8;

// if a searchpattern is given
if ($pattern) {
        // get mode-string or build mode-string
        $mode = $_GET["mode"];
        if (!$mode) $mode = "s$syndicated-p$polling-a$approval";
        // build a string containing the choosen stats
        if (strstr("$mode", "s1-")) $stats = "-Syndicated-";
        if (strstr("$mode", "-p1"))  $stats .= "-Polling-";
        if (strstr("$mode", "-a1")) $stats .= "-AwaitingApproval-";
        // if there is no user-input for stats...
        if (!$stats) die ("<u><i>no status is specified</i></u>");
        echo "<html>\n<head>\n<title>xmlrpc</title>\n</head>\n<body>\n";
        // if it's the first interval to display - let's start at zero
        if (!$startItem) $startItem = "0";

        // make a request at syndic8.com
        $content = $news->getSyndic8("$pattern", "$syn8_lang", "$startItem", "$mode");

        // show the results - first some infos, then a navbar
        echo "<u><i>Pattern: <b>\"$pattern\"</b> / Language=$syn8_lang</i></u>\n<br><br>\n";
        echo "$content[nav]<br><br>\n";

        // go through the hits and display only the channels with the choosen stats
        foreach ($content[channels] as $key => $value) {
                extract($value);
                if (strstr($stats, "-$status-")) {
                        $x++;
                        echo utf8_decode("<a href=\"syndic8.php?get_feed=".rawurlencode("$dataurl")."&version=$rss_version\">$sitename</a><br>$description<br><br>\n");
                }
        }

     echo "$content[nav]";
     // no matching channels...
     if (!$x) echo "sorry, no channels were found.";
     echo "\n<hr><br><small><i>data by&nbsp;</i></small><a href=\"http:www.syndic8.com\"><img src=\"syndic8logo.jpg\" border=\"0\"></a>\n";
     echo "</body></html>";
}

// if a newsfeed is requested
if ($get_feed != "") {
     // make the url readable
     $get_feed = urldecode($get_feed);
     // load the rss-file from the URL
     $xml = $news->load_ext_file($get_feed);
     // prepare some specialchars for sablotron; ISO-8859-1 => UTF8
     $xml = utf8_encode($xml);
                //choose the correct stylesheet
                if ($version == "1.0") {
                        $rss = "rdf.xsl";
                } elseif ($version >= '0.91' && $version <= '0.94') {
                        // no DOCTYPE-Declaration in the rss-feed
                        if($version == "0.91") $xml = str_replace("<!DOCTYPE rss SYSTEM \"http://my.netscape.com/publish/formats/rss-0.91.dtd\">", "", $xml);
                $rss = "rss.xsl";
        }

     // build some params for xslt_process()
     $arguments = array(
          '/_xml' => $xml,
     );
     $params = array ( 'somevariable' => 'somecontent' );
     // create and process the Transformation
     $xsltproc = xslt_create();
     $result = @xslt_process($xsltproc, 'arg:/_xml', $rss, NULL, $arguments, $params);
     // if there's an error...
     if (!$result) die('<b>XSLT processing error</b><br>Error-Code: <i> '.xslt_errno($xsltproc)."</i><br>Error-String:<i>".xslt_error($xsltproc)."</i>");
     // free ressources
     xslt_free($xsltproc);

                // translate the html-entities in the result
                $trans = get_html_translation_table (HTML_ENTITIES);
                $trans = array_flip($trans);
                $result = strtr($result, $trans);

     // Output the resulting HTML in ISO-8859-1
     echo utf8_decode($result);
}
?>
